VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin

Private Declare Function DrawMenuBar Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal hIcon As Long) As Long
Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Private Declare Function DrawIconEx Lib "user32" (ByVal hdc As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Private Declare Function InsertMenu Lib "user32" Alias "InsertMenuA" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long
Private Declare Function CreatePopupMenu Lib "user32" () As Long
Private Declare Function SetMenuItemBitmaps Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal hBitmapUnchecked As Long, ByVal hBitmapChecked As Long) As Long
Private Declare Function ExtractIcon Lib "shell32.dll" Alias "ExtractIconA" (ByVal hInst As Long, ByVal lpszExeFileName As String, ByVal nIconIndex As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function TrackPopupMenu Lib "user32" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal x As Long, ByVal y As Long, ByVal nReserved As Long, ByVal hWnd As Long, lprc As RECT) As Long
Private Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long
Private Declare Function DestroyMenu Lib "user32" (ByVal hMenu As Long) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal flgs As Long) As Long
Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Private Declare Function GetWindowWord Lib "user32" (ByVal hWnd As Long, ByVal wIndx As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal wIndx As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpSting As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal insaft As Long, ByVal x%, ByVal y%, ByVal cx%, ByVal cy%, ByVal flgs As Long) As Long

Const WS_MINIMIZE = &H20000000  ' Style bit 'is minimized'
Const HWND_TOP = 0              ' Move to top of z-order
Const SWP_NOSIZE = &H1          ' Do not re-size window
Const SWP_NOMOVE = &H2          ' Do not reposition window
Const SWP_SHOWWINDOW = &H40     ' Make window visible/active
Const GW_HWNDFIRST = 0          ' Get first Window handle
Const GW_HWNDNEXT = 2           ' Get next window handle
Const GWL_STYLE = (-16)         ' Get Window's style bits
Const SW_RESTORE = 9            ' Restore window
Dim IsTask As Long              ' Style bits for normal task

' The following bits will be combined to define properties
' of a 'normal' task top-level window.  Any window with ' these set will be
' included in the list:
Const WS_VISIBLE = &H10000000      ' Window is not hidden
Const WS_BORDER = &H800000         ' Window has a border

' Other bits that are normally set include:
Const WS_CLIPSIBLINGS = &H4000000  ' can clip windows
Const WS_THICKFRAME = &H40000      ' Window has thick border
Const WS_GROUP = &H20000           ' Window is top of group
Const WS_TABSTOP = &H10000         ' Window has tabstop

Private Const TPM_LEFTBUTTON = &H0&
Private Const TPM_RETURNCMD = &H100&

Private Const MF_SEPARATOR = &H800&
Private Const MF_DISABLED = &H2&
Private Const MF_CHECKED = &H8&
Private Const MF_BITMAP = &H4&
Private Const MF_BYPOSITION = &H400&
Private Const MF_POPUP = &H10&
Private Const MF_STRING = &H0&


Type POINTAPI
        x As Long
        y As Long
End Type
Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Type item
    Caption As String
    type As String
    value As String
End Type
Private items() As item

Private lngNewMenu As Long
Private menuCommands() As String
Private m_sName As String
Private m_oForm As popup.frmSetup
Private m_oForm2 As popup.frmPopup
Dim tasks As CTaskList
Private Sub IBasePlugin_StartPlugin(Name As String)
    
    Dim hWnd As Long
    Dim style As Long
    Dim ret As Long
    Dim textline As String
    Dim i As Integer
    
    Test = Name
    Set oServer = CreateObject("core.CServer")
    oServer.RegisterBang Name, "!popup"
    oServer.RegisterBang Name, "!setup"
    
    Set m_oForm2 = New popup.frmPopup
    Call Load(m_oForm2)
    m_sName = Name
    
    Set tasks = New CTaskList
    tasks.Mode = tlTaskMgr
    tasks.HungTimeout = 250
    
    ReDim menuCommands(0)
    
    lngNewMenu = CreatePopupMenu
    IsTask = WS_VISIBLE Or WS_BORDER

    LoadSettings

End Sub
Private Sub IBasePlugin_StopPlugin()
    
    DestroyMenu lngNewMenu

End Sub
Private Sub IBasePlugin_Bang(Name As String, Arguments As String)
   
    Dim what As Long
    Dim P As POINTAPI
    Dim RC As RECT
    Dim i As Long
    Dim lngSubMenu As Long
        
    If LCase(Name) = "!setup" And LCase(Arguments) = LCase(m_sName) Then
        Set m_oForm = New popup.frmSetup
        Call Load(m_oForm)
        m_oForm.Tag = m_sName
        m_oForm.Form_Setup
        m_oForm.Show 1
        LoadSettings
    End If
        
    If LCase(Name) = "!popup" And LCase(Arguments) = LCase(m_sName) Then
        DestroyMenu lngNewMenu
        lngNewMenu = CreatePopupMenu
        For i = 1 To UBound(items)
            Select Case LCase(items(i).type)
            Case "folder"
                lngSubMenu = CreatePopupMenu
                addDir items(i).value, lngSubMenu
                Call AppendMenu(lngNewMenu, MF_STRING Or MF_BYPOSITION Or MF_POPUP, lngSubMenu, items(i).Caption)
            Case "command"
                ReDim Preserve menuCommands(UBound(menuCommands) + 1)
                menuCommands(UBound(menuCommands)) = items(i).value
                Call InsertMenu(lngNewMenu, 0, MF_STRING, UBound(menuCommands), items(i).Caption)
            Case "seperator"
                Call InsertMenu(lngNewMenu, 0, MF_SEPARATOR Or MF_DISABLED, UBound(menuCommands), vbNullString)
            Case "tasks"
                If oServer.evalBool(oServer.GetKey(m_sName, "taskfolder")) Then
                    lngSubMenu = CreatePopupMenu
                    LoadTasks lngSubMenu
                    Call AppendMenu(lngNewMenu, MF_STRING Or MF_BYPOSITION Or MF_POPUP, lngSubMenu, items(i).Caption)
                Else
                    LoadTasks lngNewMenu
                End If
            End Select
        Next i
        
        Call GetCursorPos(P)
        what = TrackPopupMenu(lngNewMenu, TPM_RETURNCMD Or TPM_LEFTBUTTON, P.x, P.y, 0, m_oForm2.hWnd, RC)
        If what > 0 Then
            If Left(menuCommands(what), 5) = "task:" Then
                what = CLng(Right(menuCommands(what), Len(menuCommands(what)) - 5))
                Switch what
            Else
                oServer.Execute menuCommands(what)
            End If
        End If
    End If
    
End Sub
Private Property Get IBasePlugin_Name() As String

    IBasePlugin_Name = m_sName

End Property
Private Sub addDir(whatdir As String, menu As Long)

    Dim textline As String
    Dim lngNewMenu As Long
    Dim counter As Long
    Dim dirlist() As String
    Dim i As Long
    Dim iconmod As String
    Dim Iconh As Long
    Dim hModule As Long
    
    ReDim dirlist(0)
    counter = 0
    textline = Dir(whatdir, vbNormal + vbDirectory)
    
    While textline <> ""
        ReDim Preserve dirlist(UBound(dirlist) + 1)
        dirlist(UBound(dirlist)) = textline
        textline = Dir
    Wend
        
    For i = 1 To UBound(dirlist)
        If dirlist(i) <> "." And dirlist(i) <> ".." Then
            If GetAttr(whatdir & dirlist(i)) = vbDirectory Then
                lngNewMenu = CreatePopupMenu
                counter = counter + 1
                textline = dirlist(i)
                textline = UCase(Left(textline, 1)) & LCase(Right(textline, Len(textline) - 1))
                Call AppendMenu(menu, MF_STRING Or MF_BYPOSITION Or MF_POPUP, lngNewMenu, textline)
                addDir whatdir & dirlist(i) & "\", lngNewMenu
            Else
                ReDim Preserve menuCommands(UBound(menuCommands) + 1)
                menuCommands(UBound(menuCommands)) = whatdir & dirlist(i)
                counter = counter + 1
                textline = dirlist(i)
                If InStr(dirlist(i), ".") Then
                    textline = Left(textline, InStr(textline, ".") - 1)
                End If
                textline = UCase(Left(textline, 1)) & LCase(Right(textline, Len(textline) - 1))
                Call AppendMenu(menu, MF_STRING Or MF_BYPOSITION, UBound(menuCommands), textline)
            End If
        End If
    Next i
    
End Sub
Private Sub Switch(hWnd As Long)
               
    tasks.Activate hWnd:=hWnd
    
End Sub
Private Sub LoadTasks(menu As Long)

    Dim i As Long
    
    tasks.Refresh
    For i = 1 To tasks.Count
       
        If oServer.evalBool(oServer.GetKey(m_sName, "hidecore")) And LCase(tasks.Caption(i)) = "core" Then
        Else
            ReDim Preserve menuCommands(UBound(menuCommands) + 1)
            menuCommands(UBound(menuCommands)) = "task:" & tasks.hWnd(i)
            Call AppendMenu(menu, MF_STRING Or MF_BYPOSITION, UBound(menuCommands), tasks.Caption(i))
        End If
   Next i

End Sub
Private Sub LoadSettings()
        
    Dim i As Long
    Dim textline As String
    
    ReDim items(0)
    i = 1
    
    textline = oServer.GetKey(m_sName, "popup1")
    While textline <> ""
        If InStr(textline, ",") Then
            ReDim Preserve items(UBound(items) + 1)
            items(UBound(items)).Caption = Left(textline, InStr(textline, ",") - 1)
            textline = Right(textline, Len(textline) - InStr(textline, ","))
            If InStr(textline, ":") Then
                items(UBound(items)).type = Left(textline, InStr(textline, ":") - 1)
                items(UBound(items)).value = Right(textline, Len(textline) - InStr(textline, ":"))
            Else
                items(UBound(items)).type = textline
            End If
        End If
        i = i + 1
        textline = oServer.GetKey(m_sName, "popup" & i)
    Wend

End Sub
